local g = 9.81;
local ppm = 50; -- pixels per meter.

local function Gnomario_World_AtEdge(self)

end

local function Gnomario_World_OnGround(self)
	return self.grounded;
end
local function Gnomario_World_AtWall(self)
	return (self.grounded and self.obstructed);
end
local function Gnomario_World_Jump(self)
	if self.grounded then
		self.forceV = 5.25;
		PlaySoundFile([[Interface\AddOns\Gnomario\Sounds\jump.ogg]]);
	end
end


local function Apply_Physics(self)
	self.AtEdge = Gnomario_World_AtEdge;
	self.OnGround = Gnomario_World_OnGround;
	self.AtWall = Gnomario_World_AtWall;
	self.Jump = Gnomario_World_Jump;
end

local function Gnomario_Physics_Add(self, object)
	table.insert(self.objects, object);
end

local function Gnomario_Physics_Step(self, duration)
	for n = 1, #self.objects do
		local obj = self.objects[n];
		local x,y = obj.x, obj.y;
		if not obj.static then
			obj.forceV = (obj.forceV or 0) - ( (obj.g or g) * duration );
			if obj.forceV ~= 0 then
				obj.grounded = false;
			end
			y = y + (obj.forceV * duration * ppm);
			if y <= 0 then y = 0 obj.grounded = true; obj.forceV = 0; end

			if ( obj.grounded ) then
				x = x + ( (obj.forceH or 0) * duration * ppm )
				obj.offsetH = obj.forceH;
			else
				x = x + ( (obj.offsetH or 0) * duration * ppm )
			end
			-- bla bla bla collision test goes here
			obj.x,obj.y = x,y;
		end
	end
end

local function Gnomario_Physics_Put(self, obj, x, y)
	obj.x = x;
	obj.y = y;
	Apply_Physics(obj);
	table.insert(self.objects, obj);
end

function Gnomario_Physics_Chamber(width,height,callback)
	local chamber = {};
	chamber.width = width;
	chamber.height = height;
	chamber.objects = {};
	chamber.callback = callback;
	chamber.Step = Gnomario_Physics_Step;
	chamber.Add = Gnomario_Physics_Add;
	chamber.Put = Gnomario_Physics_Put;
	return chamber;
end

